/* testsub.c
        by Steven L. Barnicki, Feb. 1998, tests calls to subroutines
*/

#include <common.h>
#include <ports.h>



/* prototypes */
void f1(void);
void f2(byte a);
void f3(byte a, byte b);
void f4(byte a, byte b, int c);
byte f5(void);
byte f6(byte a);
byte f7(byte a, byte b);
byte f8(byte a, byte b, int c);
byte f9(int a, int b, int c);
int f10(void);
int f11(byte a, byte b);
int f12(byte a, byte b, int c);
int f13(int a, int b, int c);

void main(void)
{
  byte a=1;
  byte b=2;
  byte c=3;
  byte rb;
  int ai=4;
  int bi=5;
  int ci=6;
  int ri;

  f1();
  f2(a);
  f3(a,b);
  f4(a,b,c);
  rb=f5();
  rb=f6(a);
  rb=f7(a,b);
  rb=f8(a,b,ci);
  rb=f9(ai,bi,ci);
  ri=f10();
  ri=f11(a,b);
  ri=f12(a,b,ci);
  ri=f13(ai,bi,ci);
} /* main() */


void f1(void)
{
  int i;
  i=8;
  portb=i;
}

void f2(byte a)
{
  byte af;
  af=a;
  portc=af;
}

void f3(byte a, byte b)
{
  byte af;
  byte bf;
  af=a;
  bf=b;
  portc=af;
  portc=bf;
}

void f4(byte a, byte b, int c)
{
  byte af;
  byte bf;
  int cf;
  af=a;
  bf=b;
  cf=c;
  portc=af;
  portc=bf;
  portb=cf;
}

byte f5(void)
{
  byte b=22;
  return b;
}

byte f6(byte a)
{
  byte af;
  byte rf;
  af=a;
  portc=af;
  rf=22;
  return rf;
}

byte f7(byte a, byte b)
{
  byte af;
  byte bf;
  byte rf;
  af=a;
  bf=b;
  portc=af;
  portc=bf;
  rf=22;
  return rf;
}

byte f8(byte a, byte b, int c)
{
  byte af;
  byte bf;
  int cf;
  byte rf;
  af=a;
  bf=b;
  cf=c;
  portc=af;
  portc=bf;
  portb=cf;
  rf=22;
  return rf;
}
  
byte f9(int a, int b, int c)
{
  int af;
  int bf;
  int cf;
  byte rf;
  af=a;
  bf=b;
  cf=c;
  portb=af;
  portb=bf;
  portb=cf;
  rf=22;
  return rf;
}

int f10(void)
{
  int b=22;
  return b;
}

int f11(byte a, byte b)
{
  byte af;
  byte bf;
  int rf;
  af=a;
  bf=b;
  portc=af;
  portc=bf;
  rf=22;
  return rf;
}

int f12(byte a, byte b, int c)
{
  byte af;
  byte bf;
  int cf;
  int rf;
  af=a;
  bf=b;
  cf=c;
  portc=af;
  portc=bf;
  portb=cf;
  rf=22;
  return rf;
}

int f13(int a, int b, int c)
{
  int af;
  int bf;
  int cf;
  int rf;
  af=a;
  bf=b;
  cf=c;
  portb=af;
  portb=bf;
  portb=cf;
  rf=22;
  return rf;
}

